/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20161210-64(RM)
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-1.aml, Thu Mar  9 11:45:36 2017
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000490 (1168)
 *     Revision         0x02
 *     Checksum         0xE2
 *     OEM ID           "Intel"
 *     OEM Table ID     "PerfTune"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20120913 (538052883)
 */
DefinitionBlock ("", "SSDT", 2, "Intel", "PerfTune", 0x00001000)
{
    /*
     * External declarations were imported from
     * a reference file -- refs.txt
     */

    External (_GPE.MMTB, MethodObj)    // Imported: 0 Arguments
    External (_GPE.VHOV, MethodObj)    // Imported: 3 Arguments
    External (_SB_.PCI0.GFX0.DD02._BCM, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECMD, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECRD, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECWT, MethodObj)    // Imported: 2 Arguments
    External (_SB_.PCI0.PEG0.PEGP.SGPO, MethodObj)    // Imported: 2 Arguments
    External (_SB_.PCI0.SAT0.SDSM, MethodObj)    // Imported: 4 Arguments
    External (_SB_.PCI0.XHC_.RHUB.TPLD, MethodObj)    // Imported: 2 Arguments
    External (ADBG, MethodObj)    // 1 Arguments
    External (HMIO, IntObj)
    External (MDBG, MethodObj)    // Imported: 1 Arguments
    External (PFTU, IntObj)
    External (SFCF, IntObj)
    External (XMPB, FieldUnitObj)
    External (XTUB, FieldUnitObj)
    External (XTUS, FieldUnitObj)

    Scope (\_SB)
    {
        Device (PTMD)
        {
            Name (_HID, EisaId ("INT3394"))  // _HID: Hardware ID
            Name (_CID, EisaId ("PNP0C02"))  // _CID: Compatible ID
            Name (IVER, 0x00010000)
            Name (SIZE, 0x055C)
            Method (GACI, 0, NotSerialized)
            {
                Name (RPKG, Package (0x02) {})
                Store (Zero, Index (RPKG, Zero))
                If (LNotEqual (XTUB, Zero))
                {
                    ADBG ("XTUB")
                    ADBG (XTUB)
                    ADBG ("XTUS")
                    ADBG (XTUS)
                    OperationRegion (XNVS, SystemMemory, XTUB, SIZE)
                    Field (XNVS, ByteAcc, NoLock, Preserve)
                    {
                        XBUF,   10976
                    }

                    Name (TEMP, Buffer (XTUS) {})
                    Store (XBUF, TEMP)
                    Store (TEMP, Index (RPKG, One))
                }
                Else
                {
                    ADBG ("XTUB ZERO")
                    Store (Zero, Index (RPKG, One))
                }

                Return (RPKG)
            }

            Method (GDSV, 1, Serialized)
            {
                If (LEqual (Arg0, 0x13))
                {
                    Return (Package (0x02)
                    {
                        Zero, 
                        Buffer (0x0160)
                        {
                            /* 0000 */  0x20, 0x03, 0x00, 0x00, 0x20, 0x03, 0x00, 0x00,
                            /* 0008 */  0x84, 0x03, 0x00, 0x00, 0x84, 0x03, 0x00, 0x00,
                            /* 0010 */  0xA5, 0x03, 0x00, 0x00, 0xA5, 0x03, 0x00, 0x00,
                            /* 0018 */  0xE8, 0x03, 0x00, 0x00, 0xE8, 0x03, 0x00, 0x00,
                            /* 0020 */  0x2A, 0x04, 0x00, 0x00, 0x2A, 0x04, 0x00, 0x00,
                            /* 0028 */  0x4C, 0x04, 0x00, 0x00, 0x4C, 0x04, 0x00, 0x00,
                            /* 0030 */  0xB0, 0x04, 0x00, 0x00, 0xB0, 0x04, 0x00, 0x00,
                            /* 0038 */  0x14, 0x05, 0x00, 0x00, 0x14, 0x05, 0x00, 0x00,
                            /* 0040 */  0x35, 0x05, 0x00, 0x00, 0x35, 0x05, 0x00, 0x00,
                            /* 0048 */  0x78, 0x05, 0x00, 0x00, 0x78, 0x05, 0x00, 0x00,
                            /* 0050 */  0xBA, 0x05, 0x00, 0x00, 0xBA, 0x05, 0x00, 0x00,
                            /* 0058 */  0xDC, 0x05, 0x00, 0x00, 0xDC, 0x05, 0x00, 0x00,
                            /* 0060 */  0x40, 0x06, 0x00, 0x00, 0x40, 0x06, 0x00, 0x00,
                            /* 0068 */  0xA4, 0x06, 0x00, 0x00, 0xA4, 0x06, 0x00, 0x00,
                            /* 0070 */  0xC5, 0x06, 0x00, 0x00, 0xC5, 0x06, 0x00, 0x00,
                            /* 0078 */  0x08, 0x07, 0x00, 0x00, 0x08, 0x07, 0x00, 0x00,
                            /* 0080 */  0x4A, 0x07, 0x00, 0x00, 0x4A, 0x07, 0x00, 0x00,
                            /* 0088 */  0x6C, 0x07, 0x00, 0x00, 0x6C, 0x07, 0x00, 0x00,
                            /* 0090 */  0xD0, 0x07, 0x00, 0x00, 0xD0, 0x07, 0x00, 0x00,
                            /* 0098 */  0x34, 0x08, 0x00, 0x00, 0x34, 0x08, 0x00, 0x00,
                            /* 00A0 */  0x55, 0x08, 0x00, 0x00, 0x55, 0x08, 0x00, 0x00,
                            /* 00A8 */  0x98, 0x08, 0x00, 0x00, 0x98, 0x08, 0x00, 0x00,
                            /* 00B0 */  0xDA, 0x08, 0x00, 0x00, 0xDA, 0x08, 0x00, 0x00,
                            /* 00B8 */  0xFC, 0x08, 0x00, 0x00, 0xFC, 0x08, 0x00, 0x00,
                            /* 00C0 */  0x60, 0x09, 0x00, 0x00, 0x60, 0x09, 0x00, 0x00,
                            /* 00C8 */  0xC4, 0x09, 0x00, 0x00, 0xC4, 0x09, 0x00, 0x00,
                            /* 00D0 */  0xE5, 0x09, 0x00, 0x00, 0xE5, 0x09, 0x00, 0x00,
                            /* 00D8 */  0x28, 0x0A, 0x00, 0x00, 0x28, 0x0A, 0x00, 0x00,
                            /* 00E0 */  0x6A, 0x0A, 0x00, 0x00, 0x6A, 0x0A, 0x00, 0x00,
                            /* 00E8 */  0x8C, 0x0A, 0x00, 0x00, 0x8C, 0x0A, 0x00, 0x00,
                            /* 00F0 */  0xF0, 0x0A, 0x00, 0x00, 0xF0, 0x0A, 0x00, 0x00,
                            /* 00F8 */  0x54, 0x0B, 0x00, 0x00, 0x54, 0x0B, 0x00, 0x00,
                            /* 0100 */  0x75, 0x0B, 0x00, 0x00, 0x75, 0x0B, 0x00, 0x00,
                            /* 0108 */  0xB8, 0x0B, 0x00, 0x00, 0xB8, 0x0B, 0x00, 0x00,
                            /* 0110 */  0xFA, 0x0B, 0x00, 0x00, 0xFA, 0x0B, 0x00, 0x00,
                            /* 0118 */  0x1C, 0x0C, 0x00, 0x00, 0x1C, 0x0C, 0x00, 0x00,
                            /* 0120 */  0x80, 0x0C, 0x00, 0x00, 0x80, 0x0C, 0x00, 0x00,
                            /* 0128 */  0x05, 0x0D, 0x00, 0x00, 0x05, 0x0D, 0x00, 0x00,
                            /* 0130 */  0x8A, 0x0D, 0x00, 0x00, 0x8A, 0x0D, 0x00, 0x00,
                            /* 0138 */  0x10, 0x0E, 0x00, 0x00, 0x10, 0x0E, 0x00, 0x00,
                            /* 0140 */  0x95, 0x0E, 0x00, 0x00, 0x95, 0x0E, 0x00, 0x00,
                            /* 0148 */  0x1A, 0x0F, 0x00, 0x00, 0x1A, 0x0F, 0x00, 0x00,
                            /* 0150 */  0xA0, 0x0F, 0x00, 0x00, 0xA0, 0x0F, 0x00, 0x00,
                            /* 0158 */  0x25, 0x10, 0x00, 0x00, 0x25, 0x10, 0x00, 0x00 
                        }
                    })
                }

                Return (Package (0x01)
                {
                    One
                })
            }

            Method (GXDV, 1, Serialized)
            {
                If (LNotEqual (XMPB, Zero))
                {
                    OperationRegion (XMPN, SystemMemory, XMPB, SIZE)
                    Field (XMPN, ByteAcc, NoLock, Preserve)
                    {
                        XMP1,   704, 
                        XMP2,   704
                    }

                    If (LEqual (Arg0, One))
                    {
                        Name (XP_1, Package (0x02) {})
                        Store (Zero, Index (XP_1, Zero))
                        Store (XMP1, Index (XP_1, One))
                        Return (XP_1)
                    }

                    If (LEqual (Arg0, 0x02))
                    {
                        Name (XP_2, Package (0x02) {})
                        Store (Zero, Index (XP_2, Zero))
                        Store (XMP2, Index (XP_2, One))
                        Return (XP_2)
                    }

                    Return (Package (0x01)
                    {
                        One
                    })
                }
            }

            Method (GSCV, 0, NotSerialized)
            {
                Return (PFTU)
            }

            Method (CDRD, 1, Serialized)
            {
                Return (Package (0x01)
                {
                    One
                })
            }

            Method (CDWR, 2, Serialized)
            {
                Return (One)
            }

            Name (RPMV, Package (0x04)
            {
                One, 
                0x07, 
                Zero, 
                Zero
            })
            Name (TMP1, Package (0x0C)
            {
                One, 
                0x02, 
                Zero, 
                Zero, 
                0x05, 
                0x04, 
                Zero, 
                Zero, 
                0x06, 
                0x05, 
                Zero, 
                Zero
            })
            Name (TMP2, Package (0x08)
            {
                One, 
                0x02, 
                Zero, 
                Zero, 
                0x05, 
                0x04, 
                Zero, 
                Zero
            })
            Name (TMP3, Package (0x04)
            {
                One, 
                0x02, 
                Zero, 
                Zero
            })
            Method (TSDD, 0, NotSerialized)
            {
                Store (RTMP (), Index (TMP3, 0x02))
                Return (TMP3)
            }

            Method (FSDD, 0, NotSerialized)
            {
                Store (RFAN (), Index (RPMV, 0x02))
                Return (RPMV)
            }

            Method (SDSP, 0, NotSerialized)
            {
                Return (0x0A)
            }

            OperationRegion (IP, SystemIO, HMIO, 0x02)
            Field (IP, ByteAcc, NoLock, Preserve)
            {
                INDX,   8, 
                DAT0,   8
            }

            Method (SBYT, 2, NotSerialized)
            {
                Store (Arg0, INDX)
                Store (Arg1, DAT0)
            }

            Method (GBYT, 1, NotSerialized)
            {
                Store (Arg0, INDX)
                Store (DAT0, Local0)
                Return (Local0)
            }

            Method (RTMP, 0, NotSerialized)
            {
                If (LOr (LOr (LEqual (And (SFCF, 0x0F), 0x08), LEqual (And (SFCF, 0x0F), 0x09)), LEqual (And (SFCF, 0x0F), 0x0B)))
                {
                    Store (GBYT (0x29), Local0)
                }
                Else
                {
                    Store (GBYT (0x2B), Local0)
                }

                FindSetLeftBit (Local0, Local1)
                If (LEqual (Local1, 0x08))
                {
                    And (Local0, 0x7F, Local0)
                    Multiply (Local0, 0x0A, Local0)
                    Subtract (0x0AAC, Local0, Local0)
                }
                Else
                {
                    Multiply (Local0, 0x0A, Local0)
                    Add (0x0AAC, Local0, Local0)
                }

                Return (Local0)
            }

            Method (RFAN, 0, NotSerialized)
            {
                Store (GBYT (0x0D), Local0)
                Store (GBYT (0x18), Local1)
                Add (ShiftLeft (Local1, 0x08), Local0, Local0)
                If (LEqual (Local0, 0xFFFF))
                {
                    Return (Zero)
                }
                Else
                {
                    Return (Divide (0x00149970, Multiply (0x02, Local0), ))
                }
            }
        }
    }
}

